import processing.pdf.*;
import java.util.Calendar;

boolean savePDF = false;


float angle = 0;
float targetAngle = 0;
float easing = 0.1;

int gridSize =20;
int halfGrid = gridSize / 2;

int largeur = 851;
int hauteur = 315;

int epaisseurTrait = 2;

int nbLarge = largeur/gridSize;
int nbHauteur= hauteur/gridSize;
void setup() {
  size(10, 10);
  //Authoriser le changement de taille 
  surface.setResizable(true);
  surface.setSize(largeur, hauteur);
 }

void draw() {

  if (savePDF) beginRecord(PDF, timestamp()+".pdf");

  background(255);
  noFill();




for (int i = 0; i < nbLarge; i ++) {
  for (int j = 0; j < nbHauteur; j++) {


    pushMatrix();
    
    //Move origin to center of the each square
    translate(i*gridSize+halfGrid,j*gridSize+halfGrid);


  // get the angle from the center to the mouse position
 // angle = atan2( mouseY - height/2, mouseX - width/2 );
angle = atan2( mouseY - j*gridSize, mouseX - i*gridSize );
  // check and adjust angle to go from 0 to TWO_PI
  if ( angle < 0 ) angle = TWO_PI + angle;


    rotate( angle);
    
    
    stroke( 0 );
    strokeWeight(epaisseurTrait);
    //strokeCap(ROUND);
    strokeCap(SQUARE);
    line(-halfGrid,0,halfGrid,0);
//    line(-halfGrid+int(random(gridSize)),int(random(gridSize)),halfGrid+int(random(gridSize)),int(random(gridSize)));
    popMatrix();
  }
}

  if (savePDF) {
    savePDF = false;
    endRecord();
  }
}

void keyReleased() {  
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_####.png");
  if (key == 'p' || key == 'P') savePDF = true;
}

String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}